      IMPLICIT REAL*8 (A-H,O-Y)
      IMPLICIT COMPLEX*16 (Z)
      PARAMETER (MTOT=100 000,MZTOT=100 000,MITOT=100 000,NMESH1=5)
      DIMENSION TOT(MTOT),ITOT(MITOT),RMESH(NMESH1),ZTOT(MZTOT)
      CHARACTER*70 TITLE
      CHARACTER*55 FNOUT,FMATR,EVWFN
      COMMON /PARAM/ NN,NGRID,NWK,NNM
C
      CALL CPU_TIME(T1)	 
      NMESH = 3 
      RMESH(1) = -11.D0
      RMESH(2) = 200.D0
      RMESH(3) =  11.D0
      IBOUND = 1
      NPOL = 8
      IPRINT = 2
      IPRSTP = 34
      TMIN = 0.D0
      TMAX = 10.D0
      ITORDR = 3
      FNOUT = 'TIME.LPR'
      FMATR = 'FMATR.MAT'
      TITLE = 'ONE DIMENSIONAL TIME-DEPENDENT SCHRODINGER EQUATION'
      IOUT = 7
      IOUM = 10
      IOUF = 11
C  
      NS = 32
      IPRITT = NS
      TCC  =  1.D0
      TAU = TCC / IPRITT
      WRITE(* , *) 'TAU=',TAU
      EVWFN = 'EVWFN1_2.WFN'
C
      CALL TIME6T(TITLE,NPOL,TMIN,TMAX,TAU,ITORDR,IPRINT,IPRSTP,
     1            IPRITT,NMESH,RMESH,IBOUND,FNOUT,IOUT,FMATR,
     2            IOUM,EVWFN,IOUF,TOT,ITOT,ZTOT,MTOT,MITOT,MZTOT)
      CLOSE(IOUF)
C  
      NS = 2 * NS
      IPRITT = NS
      TAU = TCC / IPRITT
      WRITE(* , *) 'TAU=',TAU
      EVWFN = 'EVWFN2_2.WFN'
C
      CALL TIME6T(TITLE,NPOL,TMIN,TMAX,TAU,ITORDR,IPRINT,IPRSTP,
     1            IPRITT,NMESH,RMESH,IBOUND,FNOUT,IOUT,FMATR,
     2            IOUM,EVWFN,IOUF,TOT,ITOT,ZTOT,MTOT,MITOT,MZTOT)
      CLOSE(IOUF)
C  
      NS = 2 * NS
      IPRITT = NS
      TAU = TCC / IPRITT
      WRITE(* , *) 'TAU=',TAU
      EVWFN = 'EVWFN4_2.WFN'
C
      CALL TIME6T(TITLE,NPOL,TMIN,TMAX,TAU,ITORDR,IPRINT,IPRSTP,
     1            IPRITT,NMESH,RMESH,IBOUND,FNOUT,IOUT,FMATR,
     2            IOUM,EVWFN,IOUF,TOT,ITOT,ZTOT,MTOT,MITOT,MZTOT)
      CLOSE(IOUF)
C  
      NS = 2 * NS
      IPRITT = NS
      TAU = TCC / IPRITT
      WRITE(* , *) 'TAU=',TAU
      EVWFN = 'EVWFN8_2.WFN'
C
      CALL TIME6T(TITLE,NPOL,TMIN,TMAX,TAU,ITORDR,IPRINT,IPRSTP,
     1            IPRITT,NMESH,RMESH,IBOUND,FNOUT,IOUT,FMATR,
     2            IOUM,EVWFN,IOUF,TOT,ITOT,ZTOT,MTOT,MITOT,MZTOT)
      CLOSE(IOUF)
C
      IZU = 1
      IZ1 = IZU + NN * 4
      ITB  = 1
      ITX  = ITB + NWK
C
      CALL RUNGE('EVWFN1_2.WFN','EVWFN2_2.WFN','EVWFN4_2.WFN',
     1           'EVWFN8_2.WFN','FMATR.MAT','TAU6N.DAT', 
     2           ZTOT(IZU),ZTOT(IZ1),TOT(ITB),TOT(ITX),ITOT(1),NN,
     3           NGRID,NWK,NNM) 
      CALL CPU_TIME(T2)
      WRITE(*,*) T2-T1		 
C
      END
C
      SUBROUTINE RUNGE(FILE1,FILE2,FILE3,FILE4,FILE5,FILE6,ZU,ZT1,
     1                 B,XGRID,MAXA,NN,NGRID,NWK,NNM)
      IMPLICIT REAL*8 (A-H,O-Y)
      IMPLICIT COMPLEX*16 (Z)
      DIMENSION ZU(NN,4),ZT1(NN),B(NWK),MAXA(NNM),XGRID(NGRID),ERT(4)
      CHARACTER*16 FILE1,FILE2,FILE3,FILE4,FILE5,FILE6
      OPEN(1,FILE=FILE1,FORM='UNFORMATTED')
      OPEN(2,FILE=FILE2,FORM='UNFORMATTED')
      OPEN(3,FILE=FILE3,FORM='UNFORMATTED')
      OPEN(4,FILE=FILE4,FORM='UNFORMATTED')
      OPEN(5,FILE=FILE5,FORM='UNFORMATTED')
      OPEN(7,FILE=FILE6)
C
      READ(5) NWK, (B(I),I=1,NWK),NNM, (MAXA(I),I=1,NNM)
C
      WRITE(7,125)
      WRITE(*,125)
C
  123 READ(1) NN,NGRID,T,TAU,(XGRID(J),J=1,NGRID),(ZU(I,1),I=1,NN)
      READ(2) NN,NGRID,T,TAU,(XGRID(J),J=1,NGRID),(ZU(I,2),I=1,NN)
      READ(3) NN,NGRID,T,TAU,(XGRID(J),J=1,NGRID),(ZU(I,3),I=1,NN)
      READ(4) NN,NGRID,T,TAU,(XGRID(J),J=1,NGRID),(ZU(I,4),I=1,NN)
C
      DO I = 1 , 3
        DO J = 1 , NN
           ZU(J,I) = ZU(J,4) - ZU(J,I)
        END DO
        CALL MULTC(ZT1,B, ZU(1,I),MAXA,NN,NWK)
        ERT(I) = 0.D0
        DO J = 1 , NN
          ERT(I) = ERT(I) + DCONJG(ZU(J,I)) * ZT1(J)
        END DO
        ERT(I) = DSQRT(DABS(ERT(I)))
      END DO
C
      ERT(4)=DLOG10(DABS(ERT(1) - ERT(2)) / DABS(ERT(2) - ERT(3)))
      ERT(4)=ERT(4)/DLOG10(2.D0)
C
      WRITE(7,124) T,ERT(1),ERT(2),ERT(3),ERT(4)
      WRITE(*,124) T,ERT(1),ERT(2),ERT(3),ERT(4)
C
      IF ( .NOT. EOF(1)) GOTO 123   
C
      RETURN
  124 FORMAT(5E14.4)
  125 FORMAT(9X,'TT',10X,'ERT1',10X,'ERT2',10X,'ERT3',8X,'RUNGE')    
      END
C
      SUBROUTINE POTCAL(RG,TT,TAU,DA,HH,DS,SS,ITORDR)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA ZERO / 0.D0 /, ONE / 1.D0 /
C
      HH = (4 - 3 * DEXP(-TT)) * RG**2 / 2 
      SS = ZERO
      DA = ONE / 2
      DS = ZERO
C
      IF (ITORDR .GE. 2) THEN
C
        F1 = -3 * DEXP(-TT) / 24 * RG**2 / 2
        HH = HH + TAU**2 * F1
        F1 =  3 * DEXP(-TT) / 12 * RG**2 / 2
        SS = SS + TAU**2 * F1
C
      END IF 
C
      IF (ITORDR .GE. 3) THEN
C
        F1 = -3 * DEXP(-TT) * RG**2 / 2 / 1920 
     1	  + ( 3 * DEXP(-TT) * RG)**2 / 1440
     2      - (-3 * DEXP(-TT) * RG) * (4 - 3 * DEXP(-TT)) * RG / 720
        HH = HH + TAU**4 * F1
        F1 = 3 * DEXP(-TT) * RG**2 / 2 / 480
     1	   + (3 * DEXP(-TT) * RG) * (4 - 3 * DEXP(-TT)) * RG / 720
        SS = SS + TAU**4 * F1
C
        DA = DA + (- 3 * DEXP(-TT)) * TAU**4 / 720
        DS = DS - (  3 * DEXP(-TT)) * TAU**4 / 720
C
      END IF
      RETURN
      END	  	    
C
C                   INITIAL CONDITION
C 
      SUBROUTINE DINIT(KEY,NN,NGRID,XGRID,ZU1)
      IMPLICIT REAL*8 (A-H,O-Y)
      IMPLICIT COMPLEX*16 (Z)
      DIMENSION ZU1(NN),XGRID(NGRID)
      DATA ONE / 1.D0 /, TWO / 2.D0 /
      PI = DACOS(- ONE)
      FG = DSQRT(DSQRT(ONE / PI)) 
      DO I = 1 , NN
        X = XGRID(I + KEY)
        ZU1(I) = FG * DEXP( - (X - DSQRT(TWO))**2 / 2)
      END DO
      RETURN
      END